
_Write_MCP9600_Data:

;THERMO_K_click.c,31 :: 		char Write_MCP9600_Data(char RegAddr, char _data)
;THERMO_K_click.c,33 :: 		tmp_data[0] = RegAddr;                                                        // Register address
	PUSH       R2
	STS        _tmp_data+0, R2
;THERMO_K_click.c,34 :: 		tmp_data[1] = _data;
	STS        _tmp_data+1, R3
;THERMO_K_click.c,36 :: 		TWI_Start();
	CALL       _TWI_Start+0
;THERMO_K_click.c,37 :: 		TWI_Write( MCP9600_I2C_ADDR );
	LDI        R27, 192
	MOV        R2, R27
	CALL       _TWI_Write+0
;THERMO_K_click.c,38 :: 		TWI_Write( tmp_data[ 0 ] );
	LDS        R2, _tmp_data+0
	CALL       _TWI_Write+0
;THERMO_K_click.c,39 :: 		TWI_Write( tmp_data[ 1 ] );
	LDS        R2, _tmp_data+1
	CALL       _TWI_Write+0
;THERMO_K_click.c,40 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;THERMO_K_click.c,41 :: 		}
L_end_Write_MCP9600_Data:
	POP        R2
	RET
; end of _Write_MCP9600_Data

_Read_MCP9600_Data:

;THERMO_K_click.c,50 :: 		char Read_MCP9600_Data( char RegAddr )
;THERMO_K_click.c,52 :: 		tmp_data[0] = RegAddr;                                                        // Register address
	PUSH       R2
	STS        _tmp_data+0, R2
;THERMO_K_click.c,54 :: 		TWI_Start();
	CALL       _TWI_Start+0
;THERMO_K_click.c,55 :: 		TWI_Write( MCP9600_I2C_ADDR );
	LDI        R27, 192
	MOV        R2, R27
	CALL       _TWI_Write+0
;THERMO_K_click.c,56 :: 		TWI_Write( tmp_data[ 0 ] );
	LDS        R2, _tmp_data+0
	CALL       _TWI_Write+0
;THERMO_K_click.c,57 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;THERMO_K_click.c,58 :: 		Delay_us( 50 );
	LDI        R16, 133
L_Read_MCP9600_Data0:
	DEC        R16
	BRNE       L_Read_MCP9600_Data0
	NOP
;THERMO_K_click.c,59 :: 		TWI_Start();
	CALL       _TWI_Start+0
;THERMO_K_click.c,60 :: 		TWI_Write( MCP9600_I2C_ADDR | 1 );
	LDI        R27, 193
	MOV        R2, R27
	CALL       _TWI_Write+0
;THERMO_K_click.c,61 :: 		tmp_data[ 0 ] = TWI_Read( 0 );
	CLR        R2
	CALL       _TWI_Read+0
	STS        _tmp_data+0, R16
;THERMO_K_click.c,62 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;THERMO_K_click.c,64 :: 		return tmp_data[0];                                                           // Return MCP9600 Data value
	LDS        R16, _tmp_data+0
;THERMO_K_click.c,65 :: 		}
;THERMO_K_click.c,64 :: 		return tmp_data[0];                                                           // Return MCP9600 Data value
;THERMO_K_click.c,65 :: 		}
L_end_Read_MCP9600_Data:
	POP        R2
	RET
; end of _Read_MCP9600_Data

_Read_MCP9600_Status:

;THERMO_K_click.c,74 :: 		char Read_MCP9600_Status()
;THERMO_K_click.c,78 :: 		tmp_data[0] = MCP9600_Status;                                                 // Register address
	PUSH       R2
	LDI        R27, 4
	STS        _tmp_data+0, R27
;THERMO_K_click.c,80 :: 		TWI_Start();
	CALL       _TWI_Start+0
;THERMO_K_click.c,81 :: 		TWI_Write( MCP9600_I2C_ADDR );
	LDI        R27, 192
	MOV        R2, R27
	CALL       _TWI_Write+0
;THERMO_K_click.c,82 :: 		TWI_Write( tmp_data[ 0 ] );
	LDS        R2, _tmp_data+0
	CALL       _TWI_Write+0
;THERMO_K_click.c,83 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;THERMO_K_click.c,84 :: 		Delay_us( 50 );
	LDI        R16, 133
L_Read_MCP9600_Status2:
	DEC        R16
	BRNE       L_Read_MCP9600_Status2
	NOP
;THERMO_K_click.c,85 :: 		TWI_Start();
	CALL       _TWI_Start+0
;THERMO_K_click.c,86 :: 		TWI_Write( MCP9600_I2C_ADDR | 1 );
	LDI        R27, 193
	MOV        R2, R27
	CALL       _TWI_Write+0
;THERMO_K_click.c,87 :: 		tmp_data[ 0 ] = TWI_Read( 0 );
	CLR        R2
	CALL       _TWI_Read+0
	STS        _tmp_data+0, R16
;THERMO_K_click.c,88 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;THERMO_K_click.c,91 :: 		return DataSum;                                                               // Return MCP9600 Data value
	LDS        R16, _tmp_data+0
;THERMO_K_click.c,92 :: 		}
;THERMO_K_click.c,91 :: 		return DataSum;                                                               // Return MCP9600 Data value
;THERMO_K_click.c,92 :: 		}
L_end_Read_MCP9600_Status:
	POP        R2
	RET
; end of _Read_MCP9600_Status

_Read_Temperature:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 4
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;THERMO_K_click.c,101 :: 		float Read_Temperature()
;THERMO_K_click.c,105 :: 		tmp_data[0] = MCP9600_TH;                                                     // Thermocouple Temperature register
	PUSH       R2
	LDI        R27, 0
	STS        _tmp_data+0, R27
;THERMO_K_click.c,107 :: 		TWI_Start();
	CALL       _TWI_Start+0
;THERMO_K_click.c,108 :: 		TWI_Write( MCP9600_I2C_ADDR );
	LDI        R27, 192
	MOV        R2, R27
	CALL       _TWI_Write+0
;THERMO_K_click.c,109 :: 		TWI_Write( tmp_data[ 0 ] );
	LDS        R2, _tmp_data+0
	CALL       _TWI_Write+0
;THERMO_K_click.c,110 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;THERMO_K_click.c,111 :: 		Delay_us( 50 );
	LDI        R16, 133
L_Read_Temperature4:
	DEC        R16
	BRNE       L_Read_Temperature4
	NOP
;THERMO_K_click.c,112 :: 		TWI_Start();
	CALL       _TWI_Start+0
;THERMO_K_click.c,113 :: 		TWI_Write( MCP9600_I2C_ADDR | 1 );
	LDI        R27, 193
	MOV        R2, R27
	CALL       _TWI_Write+0
;THERMO_K_click.c,114 :: 		tmp_data[ 0 ] = TWI_Read( 1 );
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Read+0
	STS        _tmp_data+0, R16
;THERMO_K_click.c,115 :: 		tmp_data[ 1 ] = TWI_Read( 0 );
	CLR        R2
	CALL       _TWI_Read+0
	STS        _tmp_data+1, R16
;THERMO_K_click.c,116 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;THERMO_K_click.c,118 :: 		if((tmp_data[0] & 0x80) == 0x80){                                             // TA < 0C
	LDS        R16, _tmp_data+0
	ANDI       R16, 128
	CPI        R16, 128
	BREQ       L__Read_Temperature20
	JMP        L_Read_Temperature6
L__Read_Temperature20:
;THERMO_K_click.c,119 :: 		tmp_data[0] = tmp_data[0] & 0x7F;                                           // Clear SIGN
	LDS        R16, _tmp_data+0
	ANDI       R16, 127
	STS        _tmp_data+0, R16
;THERMO_K_click.c,120 :: 		Temperature = 1024 - (tmp_data[0]*16 + tmp_data[1] / 16);
	MOV        R18, R16
	LDI        R19, 0
	LSL        R18
	ROL        R19
	LSL        R18
	ROL        R19
	LSL        R18
	ROL        R19
	LSL        R18
	ROL        R19
	LDS        R16, _tmp_data+1
	LSR        R16
	LSR        R16
	LSR        R16
	LSR        R16
	LDI        R17, 0
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R0, R16
	LDI        R16, 0
	LDI        R17, 4
	SUB        R16, R0
	SBC        R17, R1
	LDI        R18, 0
	SBRC       R17, 7
	LDI        R18, 255
	MOV        R19, R18
	CALL       _float_slong2fp+0
; Temperature start address is: 20 (R20)
	MOVW       R20, R16
	MOVW       R22, R18
;THERMO_K_click.c,121 :: 		}
; Temperature end address is: 20 (R20)
	JMP        L_Read_Temperature7
L_Read_Temperature6:
;THERMO_K_click.c,123 :: 		Temperature = (tmp_data[0] * 16 + (float)tmp_data[1] / 16);                 // Temperature = Ambient Temperature (C)
	LDS        R16, _tmp_data+0
	LDI        R17, 0
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	LSL        R16
	ROL        R17
	STD        Y+0, R16
	STD        Y+1, R17
	LDS        R16, _tmp_data+1
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	CALL       _float_ulong2fp+0
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 128
	LDI        R23, 65
	CALL       _float_fpdiv1+0
	LDD        R20, Y+0
	LDD        R21, Y+1
	STD        Y+0, R16
	STD        Y+1, R17
	STD        Y+2, R18
	STD        Y+3, R19
	MOVW       R16, R20
	LDI        R18, 0
	SBRC       R21, 7
	LDI        R18, 255
	MOV        R19, R18
	CALL       _float_slong2fp+0
	LDD        R20, Y+0
	LDD        R21, Y+1
	LDD        R22, Y+2
	LDD        R23, Y+3
	CALL       _float_fpadd1+0
; Temperature start address is: 20 (R20)
	MOVW       R20, R16
	MOVW       R22, R18
; Temperature end address is: 20 (R20)
L_Read_Temperature7:
;THERMO_K_click.c,125 :: 		return Temperature;                                                           // Return Thermocouple temperature data
; Temperature start address is: 20 (R20)
	MOVW       R16, R20
	MOVW       R18, R22
; Temperature end address is: 20 (R20)
;THERMO_K_click.c,126 :: 		}
;THERMO_K_click.c,125 :: 		return Temperature;                                                           // Return Thermocouple temperature data
;THERMO_K_click.c,126 :: 		}
L_end_Read_Temperature:
	POP        R2
	ADIW       R28, 3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Read_Temperature

_updateLabel:

;THERMO_K_click.c,135 :: 		void updateLabel(char *newText, int x, int y, char* lbl)
;THERMO_K_click.c,137 :: 		Lcd_Out( 2, 5, newText );
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	MOVW       R4, R2
	LDI        R27, 5
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;THERMO_K_click.c,138 :: 		}
L_end_updateLabel:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _updateLabel

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;THERMO_K_click.c,143 :: 		void main()
;THERMO_K_click.c,147 :: 		Lcd_Init();                        // Initialize LCD
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R8
	PUSH       R9
	CALL       _Lcd_Init+0
;THERMO_K_click.c,148 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;THERMO_K_click.c,149 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;THERMO_K_click.c,150 :: 		Lcd_Out( 1, 2, "Thermo K click" );
	LDI        R27, #lo_addr(?lstr1_THERMO_K_click+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr1_THERMO_K_click+0)
	MOV        R5, R27
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;THERMO_K_click.c,151 :: 		TWI_Init( 100000 );
	IN         R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	OUT        TWPS0_bit+0, R27
	IN         R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	OUT        TWPS1_bit+0, R27
	LDI        R27, 32
	OUT        TWBR+0, R27
	CALL       _TWI_Init+0
;THERMO_K_click.c,152 :: 		Delay_ms( 200 );                                                                // Delay 200 ms
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L_main8:
	DEC        R16
	BRNE       L_main8
	DEC        R17
	BRNE       L_main8
	DEC        R18
	BRNE       L_main8
	NOP
;THERMO_K_click.c,154 :: 		while(1){
L_main10:
;THERMO_K_click.c,155 :: 		tk_status = &Read_MCP9600_Status;
	LDI        R27, #lo_addr(_Read_MCP9600_Status+0)
	STS        _tk_status+0, R27
;THERMO_K_click.c,156 :: 		Temp_Data_Ready = ( tk_status & 0x40 );
	LDS        R16, _tk_status+0
	ANDI       R16, 64
	STS        _Temp_Data_Ready+0, R16
;THERMO_K_click.c,158 :: 		if (Temp_Data_Ready){                                                       // Check is Temperature Data ready
	TST        R16
	BRNE       L__main23
	JMP        L_main12
L__main23:
;THERMO_K_click.c,159 :: 		sprintf(txt, "%2.1f C", Read_Temperature());                              // Format Temperature Data and store it to txt
	CALL       _Read_Temperature+0
	PUSH       R19
	PUSH       R18
	PUSH       R17
	PUSH       R16
	LDI        R27, hi_addr(?lstr_2_THERMO_K_click+0)
	PUSH       R27
	LDI        R27, #lo_addr(?lstr_2_THERMO_K_click+0)
	PUSH       R27
	LDI        R27, hi_addr(_txt+0)
	PUSH       R27
	LDI        R27, #lo_addr(_txt+0)
	PUSH       R27
	CALL       _sprintf+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 8
	OUT        SPL+0, R26
	OUT        SPL+1, R27
;THERMO_K_click.c,160 :: 		res = strcmp(txt,old_txt);                                                // Compare old_txt and txt
	LDI        R27, #lo_addr(_old_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_old_txt+0)
	MOV        R5, R27
	LDI        R27, #lo_addr(_txt+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R3, R27
	CALL       _strcmp+0
;THERMO_K_click.c,162 :: 		if(res != 0){                                                             // If old_txt and txt are not equal
	CPI        R16, 0
	BRNE       L__main24
	JMP        L_main13
L__main24:
;THERMO_K_click.c,163 :: 		updateLabel(txt, 135, 90, lab1);                                        // Write temperature value on display
	LDI        R27, #lo_addr(_lab1+0)
	MOV        R8, R27
	LDI        R27, hi_addr(_lab1+0)
	MOV        R9, R27
	LDI        R27, 90
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	LDI        R27, 135
	MOV        R4, R27
	LDI        R27, 0
	MOV        R5, R27
	LDI        R27, #lo_addr(_txt+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R3, R27
	CALL       _updateLabel+0
;THERMO_K_click.c,164 :: 		strcpy(old_txt,txt);                                                    // Copy txt to old_txt string array
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, #lo_addr(_old_txt+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_old_txt+0)
	MOV        R3, R27
	CALL       _strcpy+0
;THERMO_K_click.c,165 :: 		}
L_main13:
;THERMO_K_click.c,166 :: 		}
L_main12:
;THERMO_K_click.c,167 :: 		Delay_ms(500);
	LDI        R18, 21
	LDI        R17, 75
	LDI        R16, 191
L_main14:
	DEC        R16
	BRNE       L_main14
	DEC        R17
	BRNE       L_main14
	DEC        R18
	BRNE       L_main14
	NOP
;THERMO_K_click.c,168 :: 		}
	JMP        L_main10
;THERMO_K_click.c,169 :: 		}
L_end_main:
	POP        R9
	POP        R8
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
